#pragma once
#include "vec3.h"
struct Sphere;

const Scalar MISS = +INFINITY;

struct Ray {
    Vec3 origin;
    Vec3 direction;

    Vec3 pos(Scalar k) const {
        return origin + k * direction; //punto sul raggio
    }

    Ray(Vec3 o, Vec3 d) {
        origin = o;
        direction = d.normalized();
    }

    Scalar intersect(Sphere s); //dato che è solo dichiarato basta solo definire la classe/struct Sphere
};
/*sistema q=p+kd^
magnitude|q-c|=r
q punto sulla sfera, c centro, p punto, d direzione unitaria
||p+kd-c|| = r*/